/*****************************************************************************

        GRAOUMF TRACKER 2
        Author: Laurent de Soras, 1996-2016

--- Legal stuff ---

This program is free software. It comes without any warranty, to
the extent permitted by applicable law. You can redistribute it
and/or modify it under the terms of the Do What The Fuck You Want
To Public License, Version 2, as published by Sam Hocevar. See
http://sam.zoy.org/wtfpl/COPYING for more details.

*****************************************************************************/



#if defined (S2D_CURRENT_HEADER)
	#error Inclusion recursive du header S2D.
#endif
#define	S2D_CURRENT_HEADER

#if ! defined (S2D_HEADER_INCLUDED)
#define	S2D_HEADER_INCLUDED



/*\\\ INCLUDES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#include	"archi.h"



/*\\\ CONSTANTES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ TYPES & STRUCTURES PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ PROTOTYPES DES FONCTIONS PUBLIQUES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

int	S2D_get_byte_resolution (void);
int	S2D_get_stereo (void);
long	S2D_get_frequency (void);
long	S2D_get_max_duration_sample (void);
int	S2D_get_songpos (int pos_type);
int	S2D_get_linepos (int pos_type);
int	S2D_get_quality (void);
int	S2D_get_window_width (void);

void	S2D_set_byte_resolution (int val);
void	S2D_set_stereo (int val);
void	S2D_set_quality (int quality);
void	S2D_set_window_width (int width);

void	S2D_set_songpos_intr (int type, int value, int pos_type);
void	S2D_set_linepos_intr (int type, int value, int pos_type);
void	S2D_set_frequency_intr (int type, SLWORD value);
void	S2D_set_max_duration_intr (int type, long value);
void	S2D_set_window_width_intr (int type, int value);
void	S2D_set_sample_group_intr (int type, int value);

int	S2D_record_module (bool all_flag);
int	S2D_record_data (const char *filename_0, bool all_flag);



/*\\\ VARIABLES EXTERNES \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/



/*\\\ FIN DU FICHIER \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

#endif

#undef S2D_CURRENT_HEADER
